/****************************************************  Custom Functions  *****************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	The following functions support customer specific features added to the base Signal Stream product.

	Rev History:  08-21-2014:	Inital release.

	Copyright 2014, Red Rapids, Inc.

****************************************************  Custom Functions  *****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "adapter.h"
#include "sigstream.h"
#include "dma_functions.h"
#include "common_functions.h"
#include "channel_functions.h"

// Read the azimuth counter value recorded during the last trigger.
// Returns the azimuth counter value.
unsigned long GetAzimuth(s_Adapter *p_HW, unsigned long ChannelNumber)
{
	unsigned long long Value = 0;
	unsigned long long ConfirmValue = 0;
	
	// Perform a double read to ensure that the counter is not transitioning.
	do
	{
		Read(p_HW, BAR2, ChannelNumber << 12 | IF_DPKT_FORMAT1, &Value);
		Read(p_HW, BAR2, ChannelNumber << 12 | IF_DPKT_FORMAT1, &ConfirmValue);
	}
	while ((Value & 0xFFFFFFFF00000000ull) != (ConfirmValue & 0xFFFFFFFF00000000ull));

	return((unsigned long)((Value >> 32) & 0x00000000FFFFFFFFull));
}
